-- 编码

XLPrint("[GYX][UPC] TaskScript loaded")

-- ******* 一些积分平台及迅雷客户端提供的常用接口 ****** --
-- 1. XLGetGlobal("UserPointsCenter.CommonHelper"):GenerateJumpKeyUrl(url)
-- 	说明：产生带迅雷用户登录态的url
--		@param url:传入的普通url
--  	@return: 带迅雷用户登录态的url
-- ***************************************************** --

local pathUtility = XLGetObject("xl.filesystem.path_utility")
local taskFilename = pathUtility:get_file_name(__document)

local taskHelper = XLGetGlobal("UserPointsCenter.TaskHelper")
local taskId = taskHelper:GetTaskIdByDocument(taskFilename) 

-- 描述任务信息的table
-- name：用于显示任务的名称
-- desc：用于显示任务详情里的描述
-- state：任务状态，0未完成，1已完成，2进行中，3已领取，4已达积分上限，5任务已下架
-- show：是否显示，0不显示，1显示
-- statusDesc：用于显示状态详情里的描述
-- cd：冷却时间 -1为不需要等冷却时间
-- autoreward：任务完成后是否自动领取积分
-- repeatable：是否为重复任务
-- finishedTimes：已完成的次数

local infoTable = {}
infoTable["name"] = "启动迅雷游戏盒子送银豆"
infoTable["desc"] = '登录启动游戏盒子，即可完成任务。\r\n注：如本地电脑没有安装游戏盒子，点击“去完成”按钮，即可在迅雷7上创建任务，帮助下载安装盒子。'
infoTable["state"] = 0
infoTable["show"] = 1
infoTable["statusDesc"] = "任务完成后请点击“去领取”领取银豆"
infoTable["cd"] = 0
infoTable["autoreward"] = 0
infoTable["repeatable"] = 0
infoTable["finishedTimes"] = 0
infoTable["totalTimes"] = 1


----------------------------
-- 建立后台任务下载游戏盒子
local GameBoxTaskBasic = nil --向xl7添加下载任务的一个记录变量
local bInstFinished = nil   --是否安装完成
local timerId = nil --检测盒子是否启动的轮询定时器Id
local boxconfig = 'http://v2.boxcfg.niu.xunlei.com/xl7_updategamebox.cfg'
local defaultUrl = "http://down.sandai.net/xlgamebox/XLGameBoxLite2.2.14.0299.exe"

function DownAndInstGameBox(url,callBackFun)
	--如果游戏盒子正在下载安装过程 或者已经安装 界面上不再显示进度
	local downloadKernel = XLGetObject("Xunlei.DownloadKernel.DownloadKernel")
	local hr, taskMgr = downloadKernel:GetTaskMgr()
	XLPrint("[GYX][UPC] gamebox DownAndInstGameBox")
	if GameBoxTaskBasic then
		XLPrint("[GYX][UPC] gamebox GameBoxTaskBasic is not nil, callback and return")
		callBackFun("OnInstStarted")
		return
	end

	GetPackState(self,
		url,
		function(self, state, userdata)
			-- 如果没有开始，开始任务;
			-- 如果完成开始安装
			-- 如果正在下载挂载完成事件
			XLPrint("[GYX][UPC] gamebox OnGetPackState"..state)
			if state == "NotStart" then
				local result, taskBasic = CreateDownloadTaskXLGameBox(url)
				OnPackDownloading(self, taskBasic)
				callBackFun("OnStarting",taskBasic)
			elseif state == "Finish" then
				local taskBasic = userdata
				OnPackFinish(self, taskBasic)
				callBackFun("OnStarting",taskBasic)
			elseif state == "Downloading" then
				local taskBasic = userdata
				OnPackDownloading(self, taskBasic)
				local result = taskBasic:StartAsync()
				callBackFun("OnStarting",taskBasic)
			else
				XLPrint("错误的任务状态 state = " .. state)
				local taskBasic = userdata
				TaskMgr:DestroyTaskAsync(taskBasic, 0)
				
				local result, taskBasic = CreateDownloadTaskXLGameBox(url)
				OnPackDownloading(self, taskBasic)
				callBackFun("OnStarting",taskBasic)
			end
		end
	)
end

function GetPackState(self, url,OnGetPackState)
	XLPrint("[GYX][UPC] gamebox GetPackState()")
	local downloadKernel = XLGetObject("Xunlei.DownloadKernel.DownloadKernel")
	local hr, taskMgr = downloadKernel:GetTaskMgr()
	-- 查找p2sp任务
	local function FindTaskComplete(taskmgr, callbackRet, callbackData)
		XLPrint("[GYX][UPC] gamebox FindTaskComplete() callbackRet="..callbackRet)
		if callbackRet == 1 then -- 没找到
			OnGetPackState(self, "NotStart")
			return
		end
	end
	local hasFindOne = false
	local function FindTaskItemFound(taskmgr, callbackData, foundTask)
		XLPrint("[GYX][UPC] gamebox FindTaskItemFound() ")
		-- 兼容建立过多个任务
		if hasFindOne == true then
			return
		end
		hasFindOne = true
		
		local hr, fileName = foundTask:GetName()
		local result, taskBasic = foundTask:GetBasic()
		local hr, status = taskBasic:GetStatus()
		XLPrint("[GYX][UPC] gamebox FindTaskItemFound() fileName="..tostring(fileName)..", status="..tostring(status))
		if status == 8 then
			local result, path = foundTask:GetSavePath()
			local file_utility = XLGetObject("xl.filesystem.file_utility")
			local exist = file_utility:is_file_exist(path..tostring(fileName))
			XLPrint("[GYX][UPC] gamebox FindTaskItemFound status == 8 , filepath ="..path..fileName..", exist ="..tostring(exist))
			if exist == true then
				OnGetPackState(self, "Finish", taskBasic)
			else
				OnGetPackState(self, "FinishButNotExist", taskBasic)
			end
		else
			OnGetPackState(self, "Downloading", taskBasic)
		end
	end
	local callbackArray = {Complete=FindTaskComplete, ItemFound=FindTaskItemFound}
	taskMgr:FindTaskAsync(0, url, 2, callbackArray, 0)
end

function CreateDownloadTaskXLGameBox(url)
	local downloadKernel = XLGetObject("Xunlei.DownloadKernel.DownloadKernel")
	local result, taskMgr = downloadKernel:GetTaskMgr()	
	local thunderpath = XLGetObject("Xunlei.Thunder.Path")
	local directory = thunderpath:GetDataPath()
	local hrP2spDownloadHelper, p2spDownloadHelper = downloadKernel:GetP2spDownloadHelper()
	local hrFileName, fileName = p2spDownloadHelper:ParseFileNameFromUrlPath(url)
	local result, p2spTask = taskMgr:CreateP2spTask(url, "", directory, fileName, "")
	XLPrint("[GYX][UPC] gamebox CreateP2spTask() url="..url..", directory="..directory..", result="..result)
	local task = p2spTask:GetBasedObject()
	
	local hr, taskExtra = task:GetExtra()
	
	result, taskBasic = task:GetBasic()
	result = task:Commit()
	result = taskBasic:StartAsync()

	return result, taskBasic
end

function OnPackDownloading(self,taskBasic)
	local downloadKernel = XLGetObject("Xunlei.DownloadKernel.DownloadKernel")
	local result, TaskMgr = downloadKernel:GetTaskMgr()
	if GameBoxTaskBasic then
        return
    end
	GameBoxTaskBasic = taskBasic
	local result, taskId = taskBasic:GetId() 
	-- 需要继续下载
	local hr, statusCookie = TaskMgr:AttachTaskBasicEvent("StatusChanged",
		function(tmpTaskBasic, preStatus)
			local result, tmpTaskId = tmpTaskBasic:GetId() 
			XLPrint("[GYX][UPC] gamebox  tmpTaskId="..tostring(tmpTaskId)..", taskId="..tostring(taskId))
			if tmpTaskId ~= taskId then
				return
			end
			
			local hr, status = tmpTaskBasic:GetStatus()
			XLPrint("[GYX][UPC] gamebox OnPackDownloading status="..tostring(status))
			if status == 8 then
				TaskMgr:DetachTaskBasicEvent(statusCookie)
				OnPackFinish(self, taskBasic)
			end
		end
	)
end
function OnPackFinish(self, taskBasic)
    GameBoxTaskBasic = nil
	XLPrint("[GYX][UPC] gamebox OnPackFinished")
	local _, task = taskBasic:GetTask()
	local _, fileName = task:GetName()
	local _, savePath = task:GetSavePath()
	local filePath = tostring(savePath) .. tostring(fileName)
	XLPrint("[GYX][UPC] gamebox  filePath:" .. filePath)
	local file_utility = XLGetObject("xl.filesystem.file_utility")
	local exist = file_utility:is_file_exist(filePath)
	if not exist then
		XLPrint("[GYX][UPC] gamebox Install file does not exist")
		return
	end
	
	local osshell = XLGetObject("Xunlei.UIEngine.OSShell")
	bInstFinished = nil
    local param = '/S /b_startfrom xl7 /s_installsrc xl7 /run'
    local boxRunParam = GetJumpkeyParam()
    param = param .. ' ' .. boxRunParam .. ' '

	local asynshell = XLGetObject("Xunlei.XAF.Asyn.Shell")
		asynshell:AsynShellExecuteAndWait(filePath, function(exitcode, ret, userdata, canceled)
			XLPrint("[GYX][UPC] gamebox InstallFinished! ")
            local gameboxPath = GetGameBoxPath()
            if (gameboxPath or '') ~= '' then
                local boxRunParam = GetJumpkeyParam()
                local ret = osshell:ShellExecute(0, "open", gameboxPath, boxRunParam, '', "SW_SHOWNORMAL")
                if tonumber(ret) > 32 then
                else
                    XLPrint("[GYX][UPC] gamebox lauch fail ret="..tostring(ret))
                end
            else
                XLPrint("[GYX][UPC] gamebox InstallFinished! but not find xlgamebox.exe path!")
            end
			bInstFinished = true
		end,nil, param)
end

function ReportTaskFinished(self)
	XLPrint("[GYX][UPC] gamebox task ReportTaskFinished")
	
	local httpClient = XLGetObject("xl.win32.net.asyn_http.factory").create_instance()
	local function OnRecvCallBack(id, response)
		XLPrint("[GYX][UPC] gamebox task ReportTaskFinished OnHttpResponse")
		
		httpClient:detach_event("on_asyn_http_response")
		httpClient:detach_event("on_asyn_http_error")
		httpClient:close()
		
		local statusLine = response["Status-Line"]
		local statusCode = statusLine["Status-Code"]
		
		local resBody = response["Body"]
		resBody = string.gsub(resBody, "\r\n", "")
		
		if statusCode > 400 or resBody == nil then
			XLPrint("[GYX][UPC] gamebox task ReportTaskFinished OnHttpResponse failed")
			return
		end
		
		local decoder = XLGetGlobal("UserPointsCenter.Json")
		local ret = decoder:decode(resBody)
		if ret["result"] == nil then
			XLPrint("[GYX][UPC] gamebox task ReportTaskFinished OnHttpResponse result == nil")
			return
		end
		
		if tonumber(ret["result"]) ~= 0 then
			XLPrint("[GYX][UPC] gamebox task ReportTaskFinished OnHttpResponse error result="..tostring(ret["result"]))
			return
		end

		--self.infoTable["state"] = 1
        self.infoTable["statusDesc"] = "任务完成后请点击“去领取”领取银豆"
        --self.infoTable['finishedTimes'] = 1
		
		self:FireTaskInfoChangedEvent(self.infoTable)
	end	
	
	local function OnErrorCallBack(id, err)
		XLPrint("[GYX][UPC] gamebox task ReportTaskFinished OnErrorCallBack err="..tostring(err))
		
		httpClient:detach_event("on_asyn_http_response")
		httpClient:detach_event("on_asyn_http_error")
		httpClient:close()
	end		
	
	local LoginHelper = XLGetGlobal("UserPointsCenter.LoginHelper")
	local bIsLogin = LoginHelper:IsThunderLogin()
	if not bIsLogin then
		return
	end
	local userinfo = LoginHelper:GetUserInfo()
	local userId = userinfo.userId
	
	local body = {}	
	body["tasklist"] = {}
	body["tasklist"][1] = {}
	body["tasklist"][1]["uid"] = tostring(userId)
	body["tasklist"][1]["taskid"] = tonumber(taskId)
	
	local originalJsonStr = XLGetGlobal("Xunlei.Thunder.Json"):encode(body)
	
	local http_request = {}
	http_request['Request-Line'] = {}
	http_request['Request-Line']['Method']='POST'
	http_request['Request-Line']['Request-URI']='business_server/?request=notify_task_done&thirdbusinessid=1&datalen='..string.len(originalJsonStr)
	http_request['Request-Line']['HTTP-Version']='HTTP/1.1'
	http_request['Headers'] = {}
	http_request['Headers']['Host'] = 'task.jifen.xunlei.com:9151/'
	http_request['Headers']['Connection'] = 'close'
	
	http_request['Body'] = XLGetGlobal("UserPointsCenter.CommonHelper"):CreateTaskFinishedReportAESEncryptStr(originalJsonStr)
	http_request['Headers']['Content-Length'] = string.len(http_request['Body'])
	
	httpClient:attach_event("on_asyn_http_response", OnRecvCallBack)
	httpClient:attach_event("on_asyn_http_error", OnErrorCallBack)
	local nResult = httpClient:request(0, http_request)
	
	XLPrint("[GYX][UPC] gamebox task ReportTaskFinished request nResult="..tostring(nResult))
end

function GetBoxDownloadUrl(fnCallback)
    local httpClient = XLGetObject("xl.win32.net.asyn_http.factory").create_instance()
    local function http_on_respone(id, response)
        XLPrint("[GYX][UPC] gamebox task GetBoxDownloadUrl")
        httpClient:detach_event("on_asyn_http_response")
		httpClient:detach_event("on_asyn_http_error")
		httpClient:close()
        if fnCallback == nil then
            return
        end

        local statusLine = response["Status-Line"]
		local statusCode = statusLine["Status-Code"]
		
		local resBody = response["Body"]
		resBody = string.gsub(resBody, "\r\n", "")
		
		if statusCode > 400 or resBody == nil then
			XLPrint("[GYX][UPC] gamebox task GetBoxDownloadUrl OnHttpResponse failed " .. tostring(statusCode))
            fnCallback(defaultUrl)
			return
		end
		
		local decoder = XLGetGlobal("UserPointsCenter.Json")
		local ret = decoder:decode(resBody)
		if (ret["lite_url"] or '') == '' then
			XLPrint("[GYX][UPC] gamebox task GetBoxDownloadUrl OnHttpResponse lite_url == nil")
            fnCallback(defaultUrl)
			return
		end

        XLPrint("[GYX][UPC] gamebox task GetBoxDownloadUrl " .. tostring(ret["lite_url"]))
		fnCallback(ret["lite_url"])
    end

    local function http_on_error(id, errCode)
        httpClient:detach_event("on_asyn_http_response")
		httpClient:detach_event("on_asyn_http_error")
		httpClient:close()
        fnCallback(defaultUrl)
        XLPrint("[GYX][UPC] gamebox task GetBoxDownloadUrl error" .. tostring(errCode))
    end
    httpClient:attach_event("on_asyn_http_response", http_on_respone)
    httpClient:attach_event("on_asyn_http_error", http_on_error)

    httpClient:request(1, boxconfig)
end

----------------------------

function GetGameBoxPath()
    local osshell = XLGetObject("Xunlei.UIEngine.OSShell")
	local path = osshell:QueryRegValue("HKEY_LOCAL_MACHINE","Software\\Thunder Network\\Game\\XLGamebox","Path")
    if (path or '') == '' or not osshell:QueryFileExists(path) then
        path = osshell:QueryRegValue("HKEY_CURRENT_USER","Software\\Thunder Network\\Game\\XLGamebox","Path")
        if (path or '') == '' or not osshell:QueryFileExists(path) then
            return ''
        end

        return path
    else
        return path
    end

    return ''
end

function IsGameBoxInstalled(self)
    local osshell = XLGetObject("Xunlei.UIEngine.OSShell")
	local path = osshell:QueryRegValue("HKEY_LOCAL_MACHINE","Software\\Thunder Network\\Game\\XLGamebox","Path")
    if (path or '') == '' or not osshell:QueryFileExists(path) then
        path = osshell:QueryRegValue("HKEY_CURRENT_USER","Software\\Thunder Network\\Game\\XLGamebox","Path")
        if (path or '') == '' or not osshell:QueryFileExists(path) then
            return false
        end

        return true
    end

    return true
end

function GetJumpkeyParam()
    local objXLUser = XLGetObject("Xunlei.XLUser.Factory")
    local classUser = objXLUser:CreateInstance()
    if not classUser:IsLogIn() then
        return ''
    end
    local userInfo = classUser:GetUserInfo()
    local userName = userInfo:GetUserName()
    if (userName or '') == '' then
        userName = userInfo:GetUserNewID()
    end

    local jumpkey = userInfo:GetJumpKey()

    local jumpParam = ''
    jumpParam = jumpParam .. ' /b_username ' .. (userName or '') .. ' /b_jumpkey ' .. (jumpkey or '')
    jumpParam = jumpParam .. ' /b_comefrom 201411043452802921 '
    

    return jumpParam
end

function LauchBox(self)
    local objXLUser = XLGetObject("Xunlei.XLUser.Factory")
    local classUser = objXLUser:CreateInstance()
    if not classUser:IsLogIn() then
        return
    end

    local osshell = XLGetObject("Xunlei.UIEngine.OSShell")
    local ProcessName = 'XLGameBox.exe'
    if osshell:IsProcessExist(ProcessName) then
        XLPrint("[GYX][UPC] gamebox already lauched ")
        -- 已经安装并启动则将窗口前置
        local gameboxPath = GetGameBoxPath()
        if (gameboxPath or '') ~= '' then
            local boxRunParam = GetJumpkeyParam()
            local ret = osshell:ShellExecute(0, "open", gameboxPath, boxRunParam, '', "SW_SHOWNORMAL")
            if tonumber(ret) > 32 then
                ReportTaskFinished(self)
            end
        end
    else
        local gameboxPath = GetGameBoxPath()
        if (gameboxPath or '') ~= '' then
            -- 安装了未启动
            XLPrint("[GYX][UPC] gamebox already installed ")
            local boxRunParam = GetJumpkeyParam()
            local ret = osshell:ShellExecute(0, "open", gameboxPath, boxRunParam, '', "SW_SHOWNORMAL")
            if tonumber(ret) > 32 then
                ReportTaskFinished(self)
            end
        else
            -- 拉起通用下载器拉起盒子
            -- infoTable["desc"] = "下载并启动迅雷游戏盒子，奖励积分"
			-- self:FireTaskInfoChangedEvent(self.infoTable)

            local gameboxLauched = false
            
            XLPrint("[GYX][UPC] gamebox not installed ")
            -- local downloadUrl = 'http://down.sandai.net/xlgamebox/XLGameBoxLite2.2.14.0299.exe'
            function DownloadAndInstCallBack(state,callBackData)
                XLPrint("[GYX][UPC] gamebox DownloadAndInstCallBack state:"..tostring(state))
            end

            GetBoxDownloadUrl(function(downloadUrl)
                DownAndInstGameBox(downloadUrl, DownloadAndInstCallBack)
            end)

            -- 启动定时器检测盒子是否启动
            local function CheckBoxLauched(target, id)
                if id ~= timerId then
                    return
                end

                XLPrint("[GYX][UPC] gamebox check install and lauch")
                if osshell:IsProcessExist(ProcessName) then
                    XLPrint("[GYX][UPC] gamebox check lauched")
                    target:KillTimer(id)
                    timerId = nil

                    ReportTaskFinished(self)
                end
            end

            local timerManger = XLGetObject("Xunlei.UIEngine.TimerManager")
            timerId = timerManger:SetTimer(CheckBoxLauched, 3000)
        end
    end
end

-- 加载任务之后调用的接口（非用户主动点击执行的行为）
-- 用来做被动任务开始计时等操作
-- 注意：BeginTask后于SetTaskInfo执行
function BeginTask(self)
end

-- 用户主动点击任务后调用的接口
-- 用来做主动任务开始执行等操作
function ClickTask(self)
    LauchBox(self)
end

-- 停止/取消任务
-- 用来做停止被动任务计时等操作
function CancelTask(self)
    if timerId ~= nil then
        local timerManger = XLGetObject("Xunlei.UIEngine.TimerManager")
        timerManger:KillTimer(timerId)
        timerId = nil
    end
end

function RewardedTask(self)
	self.infoTable["finishedTimes"] = self.infoTable["finishedTimes"] + 1
end

-- 加载完任务后设置任务初始化信息
-- 用来设置加载完任务后从服务器返回的初始化信息
-- 注意：SetTaskInfo先于BeginTask执行
function SetTaskInfo(self, initInfo)
	self.infoTable["state"] = initInfo["state"]
	self.infoTable["cd"] = initInfo["cd"]
	self.infoTable["finishedTimes"] = initInfo["finishedTimes"]
end

-- 客户端获取任务信息的接口
-- 返回任务的信息table
function GetTaskInfo(self)
	return self.infoTable
end

-- 挂载任务信息改变事件
function AttachTaskInfoChangedEvent(self, callback, userdata)
	if self.taskInfoChangedCallbackList == nil then
		self.taskInfoChangedCallbackList = {}
	end
	
	self.taskInfoChangedCallbackListIndex = self.taskInfoChangedCallbackListIndex + 1
	self.taskInfoChangedCallbackList[self.taskInfoChangedCallbackListIndex] = {}
	self.taskInfoChangedCallbackList[self.taskInfoChangedCallbackListIndex][1] = callback
	self.taskInfoChangedCallbackList[self.taskInfoChangedCallbackListIndex][2] = userdata
	
	return self.taskInfoChangedCallbackListIndex
end

-- 卸载任务信息改变事件
function DetachTaskInfoChangedEvent(self, index)
	if self.taskInfoChangedCallbackList == nil then
		return
	end
	
	if self.taskInfoChangedCallbackList[index] ~= nil then
		self.taskInfoChangedCallbackList[index] = nil
	end
end

-- 触发任务信息改变事件
-- 例：对于被动任务，描述任务信息可能实时改变（如计时等），需要触发此事件
function FireTaskInfoChangedEvent(self, ...)
	if self.taskInfoChangedCallbackList == nil then
		return
	end
	
	for i, v in pairs(self.taskInfoChangedCallbackList) do
		if v ~= nil then
			v[1](..., v[2])
		end
	end
end

function RegisterObject()
	local obj = {}
	obj.taskId = taskId
	obj.infoTable = infoTable
	obj.taskInfoChangedCallbackListIndex = 0
	
	obj.BeginTask = BeginTask
	obj.ClickTask = ClickTask
	obj.CancelTask = CancelTask
    obj.RewardedTask = RewardedTask
	obj.SetTaskState = SetTaskState
	obj.SetTaskCD = SetTaskCD
	obj.SetTaskInfo = SetTaskInfo
	obj.GetTaskInfo = GetTaskInfo
	obj.AttachTaskInfoChangedEvent = AttachTaskInfoChangedEvent
	obj.DetachTaskInfoChangedEvent = DetachTaskInfoChangedEvent
	obj.FireTaskInfoChangedEvent = FireTaskInfoChangedEvent
	
	XLSetGlobal("UserPointsCenter.task"..tostring(taskId), obj)
	XLPrint("[GYX][UPC] TaskScript task=".."UserPointsCenter.task"..tostring(taskId))
end

RegisterObject()
